﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DroneTest
{
    public static class DroneState
    {
        // values from [-1, 1]
        public static double StrafeX { get; set; }
        public static double StrafeY { get; set; }
        public static double AscendY { get; set; }

        // flag for takeoff and landing
        public static bool Flying { get; set; }

        private static bool isFlying;

        public static string GetNextCommand(uint sequenceNumber)
        {
            // Determine if the drone needs to take off or land
            if (Flying && !isFlying)
            {
                isFlying = true;
                return DroneMovement.GetDroneTakeoff(sequenceNumber);
            }
            else if (!Flying && isFlying)
            {
                isFlying = false;
                return DroneMovement.GetDroneLand(sequenceNumber);
            }

            // if the drone is flying, sends movement commands to it.
            if (isFlying && (StrafeX != 0 || StrafeY != 0 || AscendY != 0))
                return DroneMovement.GetDroneMove(sequenceNumber, StrafeX, StrafeY, AscendY);

            return DroneMovement.GetHoveringCommand(sequenceNumber);
        }
    }
}
