﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using DroneTest.Resources;

namespace DroneTest
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private async void PhoneApplicationPage_Loaded(object sender, RoutedEventArgs e)
        {
            DroneControl.StubMode = false;
            await DroneControl.ConnectAsync();
        }

        private void takeOffButton_Click(object sender, EventArgs e)
        {
            DroneState.Flying = true;
        }

        private void landButton_Click(object sender, EventArgs e)
        {
            DroneState.Flying = false;
        }

        private void altitudeSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            DroneState.AscendY = altitudeSlider.Value;
        }

        private void altitudeSlider_MouseLeftButtonUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            altitudeSlider.Value = 0;
            DroneState.AscendY = altitudeSlider.Value;
        }

        private void forwardBackwardSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            DroneState.StrafeY = forwardBackwardSlider.Value * -1;
        }

        private void forwardBackwardSlider_MouseLeftButtonUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            forwardBackwardSlider.Value = 0;
            DroneState.StrafeY = forwardBackwardSlider.Value;
        }

        private void leftRightSlider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            DroneState.StrafeX = leftRightSlider.Value;
        }

        private void leftRightSlider_MouseLeftButtonUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            leftRightSlider.Value = 0;
            DroneState.StrafeX = leftRightSlider.Value;
        }
    }
}