﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.ApplicationModel;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.Networking.Proximity;
using DroneTest;
using Windows.UI;

namespace BasicDriveApp
{
    public sealed partial class MainPage : Page
    {
        private Joystick joystick;

        public MainPage()
        {
            this.InitializeComponent();

            altitudeSlider.AddHandler(PointerReleasedEvent, new PointerEventHandler(altitudeSlider_PointerReleased), true);
        }

        protected async override void OnNavigatedTo(NavigationEventArgs e)
        {
            joystick = new Joystick(Puck);
            joystick.Movement += Joystick_Movement;
            joystick.Stop += Joystick_Stop;

            // Si collega al drone.
            try
            {
                DroneControl.StubMode = true;
                await DroneControl.ConnectAsync();

                statusTextBlock.Text = "Connesso";
                statusTextBlock.Foreground = new SolidColorBrush(Colors.Green);
            }
            catch
            {
                statusTextBlock.Text = "Connesso";
                statusTextBlock.Foreground = new SolidColorBrush(Colors.Red);
            }

            base.OnNavigatedTo(e);
        }

        private void takeOffButton_Click(object sender, RoutedEventArgs e)
        {
            DroneState.Flying = true;
        }

        private void landButton_Click(object sender, RoutedEventArgs e)
        {
            DroneState.Flying = false;
        }

        private void Joystick_Movement(object sender, MovementEventArgs e)
        {
            DroneState.StrafeX = e.X;
            DroneState.StrafeY = e.Y;
        }

        private void Joystick_Stop(object sender, EventArgs e)
        {
            DroneState.StrafeY = 0;
            DroneState.StrafeX = 0;
        }

        private void altitudeSlider_ValueChanged(object sender, RangeBaseValueChangedEventArgs e)
        {
            DroneState.AscendY = altitudeSlider.Value;
        }

        private void altitudeSlider_PointerReleased(object sender, PointerRoutedEventArgs e)
        {
            altitudeSlider.Value = 0;
            DroneState.AscendY = altitudeSlider.Value;
        }
    }
}
