﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.Globalization.DateTimeFormatting;
using Windows.System.UserProfile;
using Windows.UI.Xaml.Data;

namespace MvvmLightExtensions.WindowsStore.Converters
{
    public sealed class DateTimeToStringConverter : IValueConverter
    {
        private static DateTimeFormatter dateFormatter;
        private static DateTimeFormatter timeFormatter;

        static DateTimeToStringConverter()
        {
            var language = GlobalizationPreferences.Languages.FirstOrDefault();
            dateFormatter = new DateTimeFormatter("shortdate", new[] { language });
            timeFormatter = new DateTimeFormatter("shorttime", new[] { language });
        }

        public object Convert(object value, Type targetType, object parameter, string language)
        {
            if (value == null)
                return string.Empty;

            try
            {
                var dateTime = (DateTime)value;
                string dateTimeString = string.Format("{0} {1}", dateFormatter.Format(dateTime), timeFormatter.Format(dateTime));
                return dateTimeString;
            }
            catch
            {
                return string.Empty;
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, string language)
        {
            throw new NotImplementedException();
        }
    }
}
