﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Popups;

namespace MvvmLightExtensions.WindowsStore.Services
{
    public class DialogMessageService : IMessageService
    {
        public async Task ShowAsync(string message, string title = null, uint defaultCommandIndex = 0, params Command[] commands)
        {
            var dialog = new MessageDialog(message, title ?? string.Empty);
            foreach (var command in commands)
            {
                var cmd = new UICommand(command.Text,
                        new UICommandInvokedHandler((c) =>
                        {
                            if (command.Action != null)
                                command.Action.Invoke();
                        }),
                        command.Id);
                dialog.Commands.Add(cmd);
            }

            dialog.DefaultCommandIndex = defaultCommandIndex;

            await dialog.ShowAsync();
        }
    }
}
