﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace MvvmLightExtensions.WindowsStore.ViewModels
{
    public abstract class NetworkAwareViewModel : BindableBase
    {
        private bool isOffline;
        public bool IsOffline
        {
            get { return isOffline; }
            set
            {
                if (this.SetProperty(ref isOffline, value))
                    OnNetworkAvailabilityChanged(isOffline);
            }
        }

        protected virtual void OnNetworkAvailabilityChanged(bool isOffline)
        { }

        public NetworkAwareViewModel()
        {
            isOffline = !Network.IsConnected;
            Network.InternetConnectionChanged += async (s, e) =>
            {
                await UIThreadActionAsync(() => IsOffline = !e.IsConnected);
            };
        }
    }
}
