/* Copyright 2012 Marco Minerva, marco.minerva@gmail.com

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
*/

using System;
using Microsoft.SPOT;
using IndianaJones.NETMF.Json;
using System.Collections;

namespace HomeAutomation
{
    public static class DataContractJsonSerializer
    {
        private static Serializer serializer;

        static DataContractJsonSerializer()
        {
            serializer = new Serializer("HomeAutomation.Objects");
        }

        public static string Serialize(object obj)
        {
            return serializer.Serialize(obj);
        }

        public static object Deserialize(string jsonString, bool singleElement = false)
        {
            var decoded = serializer.Deserialize(jsonString);
            if (decoded != null && singleElement && decoded.GetType() == typeof(ArrayList))
            {
                var array = (ArrayList)decoded;
                if (array.Count >= 0)
                    return array[0];
                return null;
            }

            return decoded;
        }
    }
}
